

#ifndef BST_H_
#define BST_H_

typedef int bst_element;

typedef struct node_tag {
	struct node_tag* parent;
	struct node_tag* left;
	struct node_tag* right;
	bst_element key;
} bst_node;

typedef struct bst_tag {
	bst_node* root;
} bst;

void init_bst(bst* t);

/* search operations */
bst_element minimum(bst* t);
bst_element maximum(bst* t);
bst_element search(bst* t, bst_element e);
bst_element predecessor(bst* t, bst_element e);
bst_element successor(bst* t, bst_element e);

/* insert operations */
void insert(bst* t, bst_element e);

/* delete operation */
void delete(bst* t, bst_element e);


#endif /* BST_H_ */




